#Import needed packages
from pylab import *
import csv
import numpy
from scipy.stats import norm

#Define formula to confirm whether a value is a floating element or a string
def isfloat(value):
    try:
        float(value)
        return True
    except ValueError:
        return False

#Load data
reader=csv.reader(open("Combined_origineel.csv","rb"),delimiter=';')
r=list(reader)
x=numpy.matrix(r)

#Count the amount of relevant rows (skip al errors) and store in a new matrix
A=0; Z=0; 
for i in range(len(x)):
    if (isfloat(x[i,2])==True) and (isfloat(x[i,3])==True) and (isfloat(x[i,4])==True) and (isfloat(x[i,5])==True) and (isfloat(x[i,6])==True):
            A = A + 1
Data = zeros([A,size(x)/len(x)-1])
for i in range(len(x)):
    if (isfloat(x[i,2])==True) and (isfloat(x[i,3])==True) and (isfloat(x[i,4])==True) and (isfloat(x[i,5])==True) and (isfloat(x[i,6])==True):
        for j in range(size(x)/len(x)-2):
            Data[Z,j]=x[i,j+2] 
            Data[Z,5] = i                        #Gives a number to trace back the date and time
        Z = Z + 1 

#Convert the data in the right dimensions [m] and [m/s]
Data[:,0]=0.01*Data[:,0]; Data[:,1]=0.01*Data[:,1]; Data[:,2]=0.01*Data[:,2]; Data[:,4]=0.1*Data[:,4]

#Convert the Data to mean data
GemData = zeros([len(Data)/6,size(Data)/len(Data)])
for i in range(len(Data)/6):
    for j in range(size(Data)/len(Data)):
            GemData[i,j] = (Data[6*i,j]+Data[6*i+1,j]+Data[6*i+2,j]+Data[6*i+3,j]+Data[6*i+4,j]+Data[6*i+5,j])/6

#Count relevant data and store in matrix
R=0; Q=0; Fetch=18200; Depth=5.4;  
for i in range(len(GemData)):
    if ((GemData[i,3] > 260) and (GemData[i,3] < 310.0) and (GemData[i,4]>13)):
        R = R + 1
PlotData = zeros([R,5])
for i in range(len(GemData)):
    if ((GemData[i,3] > 260) and (GemData[i,3] < 310.0) and (GemData[i,4]>13)):
        PlotData[Q,0]=GemData[i,4]                                              #Store wind speed
        PlotData[Q,1]=GemData[i,3]                                              #Store wind direction
        PlotData[Q,2]=GemData[i,2]-GemData[i,1]                                 #Store wind set-up at HEVW
        PlotData[Q,3]=0.5*Fetch/(Depth*9.81)*GemData[i,4]**2+0.0406873555562    #Store and compute wind set-up
        PlotData[Q,4]=PlotData[Q,2]/PlotData[Q,3]                               #Compute kappa
        Q = Q + 1

#Compute and print correlation and plot computed value wind set-up versus measured value
print 'The correlation is: ', numpy.corrcoef(PlotData[:,3], PlotData[:,2])[0, 1]
#plot(PlotData[:,3],PlotData[:,2], 'ro')

#Fit line trough data points
c,d = polyfit(PlotData[:,3],PlotData[:,2],1)
print 'fitted slope, parameter c = ',c

I=0; J=0
for i in range(len(PlotData)):
    if ((PlotData[i,0]>13)):
        I = I + 1
HIGH = zeros([I,6])
for i in range(len(PlotData)):
    if ((PlotData[i,0]>13)):
        HIGH[J,0] = PlotData[i,0]
        HIGH[J,1] = PlotData[i,1]
        HIGH[J,2] = PlotData[i,2]
        HIGH[J,3] = PlotData[i,3]
        HIGH[J,4] = PlotData[i,4]
        HIGH[J,5] = PlotData[i,4]-(c+d/PlotData[i,3])
        J = J + 1

a = boxplot(HIGH[:,5]/c*100)
ylabel('Deviation kappa [%]')
print 'Standard Deviation', np.std(PlotData[:,4])
print 'Standard Deviation', np.std(HIGH[:,5])
show()

