#Importeren benodigde packages
from pylab import *
import csv
import numpy
import string
from mpl_toolkits.axes_grid1 import host_subplot
import mpl_toolkits.axisartist as AA
import matplotlib.pyplot as plt

#Define formula to confirm whether a value is a floating element or a string
def isfloat(value):
    try:
        float(value)
        return True
    except ValueError:
        return False

#Load data
reader=csv.reader(open("Combined_origineel.csv","rb"),delimiter=';')
r=list(reader)
x=numpy.matrix(r)

#Count the amount of relevant rows (skip al errors) and store in a new matrix
A=0
for i in range(len(x)):
    if (isfloat(x[i,2])==True) and (isfloat(x[i,3])==True) and (isfloat(x[i,4])==True) and (isfloat(x[i,5])==True) and (isfloat(x[i,6])==True):
            A = A + 1
Data = zeros([A,size(x)/len(x)-1])
Z = 0
for i in range(len(x)):
    if (isfloat(x[i,2])==True) and (isfloat(x[i,3])==True) and (isfloat(x[i,4])==True) and (isfloat(x[i,5])==True) and (isfloat(x[i,6])==True):
        for j in range(size(x)/len(x)-2):
            Data[Z,j]=x[i,j+2] 
            Data[Z,5] = i    #Gives a number to trace back the date and time
        Z = Z + 1 

#Convert the data in the right dimensions [m] and [m/s]
Data[:,0]=0.01*Data[:,0]
Data[:,1]=0.01*Data[:,1]
Data[:,2]=0.01*Data[:,2]
Data[:,4]=0.1*Data[:,4]

if 1:

    host = host_subplot(111, axes_class=AA.Axes)
    plt.subplots_adjust(right=0.75)

    par1 = host.twinx()
    par2 = host.twinx()

    offset = 60
    new_fixed_axis = par2.get_grid_helper().new_fixed_axis
    par2.axis["right"] = new_fixed_axis(loc="right",
                                        axes=par2,
                                        offset=(offset, 0))

    par2.axis["right"].toggle(all=True)
    host.set_title('Storm 21/01/2007 03:50 till 21/01/2007 12:10')
    host.set_xlabel("Time [10 min / step]")
    host.set_ylabel("Waterdepth [m]")
    par1.set_ylabel("Wind direction [degree]")
    par2.set_ylabel("Wind velocity [m/s]")
    r = linspace(0,50,50)
    p1, = host.plot(r, Data[225800:225850,2], label="Waterdepth HEVW [m]", linewidth=2)
    p2, = par1.plot(r, Data[225800:225850,3], label="Wind direction [degree]", linewidth=2)
    p3, = par2.plot(r, Data[225800:225850,4], label="Wind velocity [m/s]", linewidth=2)
    p4, = host.plot(r, Data[225800:225850,0], label="Waterdepth BRBI [m]", linewidth=2)
    p5, = host.plot(r, Data[225800:225850,1], label="Waterdepth BOM1 [m]", linewidth=2)
    host.legend(loc=2)

    host.axis["left"].label.set_color(p1.get_color())
    par1.axis["right"].label.set_color(p2.get_color())
    par2.axis["right"].label.set_color(p3.get_color())
    par2.axis["right"].label.set_color(p4.get_color())
    par2.axis["right"].label.set_color(p5.get_color())

    plt.draw()
    plt.show()

print Data[225800,:]
print Data[225850,:]

print x[Data[225800,5],:]
print x[Data[225850,5],:]

