#Import needed packages
from pylab import *
import csv
import numpy

#Define formula to confirm whether a value is a floating element or a string
def isfloat(value):
    try:
        float(value)
        return True
    except ValueError:
        return False

#Load data
reader=csv.reader(open("Combined_origineel.csv","rb"),delimiter=';')
r=list(reader)
x=numpy.matrix(r)

#Count the amount of relevant rows (skip al errors) and store in a new matrix
A=0; Z=0; 
for i in range(len(x)):
    if (isfloat(x[i,2])==True) and (isfloat(x[i,3])==True) and (isfloat(x[i,4])==True) and (isfloat(x[i,5])==True) and (isfloat(x[i,6])==True):
            A = A + 1
Data = zeros([A,size(x)/len(x)-1])
for i in range(len(x)):
    if (isfloat(x[i,2])==True) and (isfloat(x[i,3])==True) and (isfloat(x[i,4])==True) and (isfloat(x[i,5])==True) and (isfloat(x[i,6])==True):
        for j in range(size(x)/len(x)-2):
            Data[Z,j]=x[i,j+2] 
            Data[Z,5] = i                        #Gives a number to trace back the date and time
        Z = Z + 1 

#Convert the data in the right dimensions [m] and [m/s]
Data[:,0]=0.01*Data[:,0]; Data[:,1]=0.01*Data[:,1]; Data[:,2]=0.01*Data[:,2]; Data[:,4]=0.1*Data[:,4]

#Convert the Data to mean data
GemData = zeros([len(Data)/6,size(Data)/len(Data)])
for i in range(len(Data)/6):
    for j in range(size(Data)/len(Data)):
            GemData[i,j] = (Data[6*i,j]+Data[6*i+1,j]+Data[6*i+2,j]+Data[6*i+3,j]+Data[6*i+4,j]+Data[6*i+5,j])/6

#Count relevant data and store in matrix
R=0; Q=0; Fetch=13700; Depth=5.4;Kappa=1.75284358034e-06

for i in range(len(GemData)):
    if (((GemData[i,3] > 250) and (GemData[i,3] < 270.0))  and (GemData[i,4]>13) and (GemData[i,4]<180)):
        R = R + 1
PlotData = zeros([R,5])
for i in range(len(GemData)):
    if (((GemData[i,3] > 250) and (GemData[i,3] < 270.0))  and (GemData[i,4]>13) and (GemData[i,4]<180)):
        PlotData[Q,0]=GemData[i,4]                                      #Store wind speed
        PlotData[Q,1]=GemData[i,3]                                      #Store wind direction
        PlotData[Q,2]=GemData[i,1]                                      #Store water depth
        PlotData[Q,3]=GemData[i,0]-GemData[i,1]-0.0229164059472          #Store wind set-up at HEVW
        PlotData[Q,4]=0.5*Fetch/(Depth*9.81)*GemData[i,4]**2*Kappa           #Store and compute wind set-up
        Q = Q + 1
#Compute and print correlation and plot computed value wind set-up versus measured value
print 'The correlation is: ', numpy.corrcoef(PlotData[:,4], PlotData[:,3])[0, 1]
plot(PlotData[:,4],PlotData[:,3], 'ro')

#Fit line trough data points
c,d = polyfit(PlotData[:,4],PlotData[:,3],1)
print 'fitted slope, parameter c = ',c
print 'fitted y-intercept parameter d = ',d
y_fit1= c*PlotData[:,4]+d
plot(PlotData[:,4], y_fit1, 'b', linewidth=3.0,label='fitted line')

DevWind = zeros([len(PlotData),2])
for i in range(len(PlotData)):
    DevWind[i,0]=PlotData[i,0]
    DevWind[i,1]=c*PlotData[i,4]-PlotData[i,3]
print 'Standard Deviation', np.std(DevWind[:,1])
y_fit2 = c*PlotData[:,4] + d+np.std(DevWind[:,1])
y_fit3 = c*PlotData[:,4] + d-np.std(DevWind[:,1])
y_fit4 = c*PlotData[:,4] + d+2*np.std(DevWind[:,1])
y_fit5 = c*PlotData[:,4] + d-2*np.std(DevWind[:,1])
y_fit6 = c*PlotData[:,4] + d+3*np.std(DevWind[:,1])
y_fit7 = c*PlotData[:,4] + d-3*np.std(DevWind[:,1])
plot(PlotData[:,4], y_fit2, 'g', linewidth=3.0,label='one times standard deviation')
plot(PlotData[:,4], y_fit3, 'g', linewidth=3.0)
plot(PlotData[:,4], y_fit4, 'y', linewidth=3.0,label='two times standard deviation')
plot(PlotData[:,4], y_fit5, 'y', linewidth=3.0)
plot(PlotData[:,4], y_fit6, 'm', linewidth=3.0,label='three times standard deviation')
plot(PlotData[:,4], y_fit7, 'm', linewidth=3.0)
xlabel('Computed value wind set-up [m]')
ylabel('Measured value wind set-up [m]')
title('Scatterplot computed versus measured wind set-up')
legend(loc=1)
show()  