#Import needed packages
from pylab import *
import csv
import numpy

#Define formula to confirm whether a value is a floating element or a string
def isfloat(value):
    try:
        float(value)
        return True
    except ValueError:
        return False

#Load data
reader=csv.reader(open("Combined_origineel.csv","rb"),delimiter=';')
r=list(reader)
x=numpy.matrix(r)

#Count the amount of relevant rows (skip al errors) and store in a new matrix
A=0; Z=0; 
for i in range(len(x)):
    if (isfloat(x[i,2])==True) and (isfloat(x[i,3])==True) and (isfloat(x[i,4])==True) and (isfloat(x[i,5])==True) and (isfloat(x[i,6])==True):
            A = A + 1
Data = zeros([A,size(x)/len(x)-1])
for i in range(len(x)):
    if (isfloat(x[i,2])==True) and (isfloat(x[i,3])==True) and (isfloat(x[i,4])==True) and (isfloat(x[i,5])==True) and (isfloat(x[i,6])==True):
        for j in range(size(x)/len(x)-2):
            Data[Z,j]=x[i,j+2] 
            Data[Z,5] = i                            #Gives a number to trace back the date and time
        Z = Z + 1 

#Convert the data in the right dimensions [m] and [m/s]
Data[:,0]=0.01*Data[:,0]; Data[:,1]=0.01*Data[:,1]; Data[:,2]=0.01*Data[:,2]; Data[:,4]=0.1*Data[:,4]

#Convert the Data to mean data
GemData = zeros([len(Data)/6,size(Data)/len(Data)])
for i in range(len(Data)/6):
    for j in range(size(Data)/len(Data)):
            GemData[i,j] = (Data[6*i,j]+Data[6*i+1,j]+Data[6*i+2,j]+Data[6*i+3,j]+Data[6*i+4,j]+Data[6*i+5,j])/6

#Count relevant data and store in matrix
R=0; Q=0; Fetch=18200; Depth=5.4;
for i in range(len(GemData)):
    if ((GemData[i,3] > 260) and (GemData[i,3] < 310.0) and (GemData[i,4]>13)):
        R = R + 1
PlotData = zeros([R,5])
for i in range(len(GemData)):
    if ((GemData[i,3] > 260) and (GemData[i,3] < 310.0) and (GemData[i,4]>13)):
        PlotData[Q,0]=GemData[i,4]                                      #Store wind speed
        PlotData[Q,1]=GemData[i,3]                                      #Store wind direction
        PlotData[Q,2]=GemData[i,1]                                      #Store water depth
        PlotData[Q,3]=GemData[i,2]-GemData[i,1]+0.0406873555562         #Store wind set-up at HEVW, corrected for the 4.1 centimetre error
        PlotData[Q,4]=0.5*Fetch/(9.81*Depth)*GemData[i,4]**2            #Store and compute wind set-up **
        Q = Q + 1

#Compute and print correlation and plot computed value wind set-up versus measured value
print 'The correlation is: ', numpy.corrcoef(PlotData[:,4], PlotData[:,3])[0, 1]
plot(PlotData[:,4],PlotData[:,3], 'ro')

#Fit line trough data points
c,d = polyfit(PlotData[:,4],PlotData[:,3],1)
print 'fitted slope, parameter c = ',c
print 'fitted y-intercept parameter d = ',d
y_fit1= c*PlotData[:,4]+d
plot(PlotData[:,4], y_fit1, 'b', linewidth=3.0,label='Mean wind set-up')

#Compute standard deviation kappa
S = zeros([len(PlotData),1])
for i in range(len(PlotData)):
    S[i,0] = PlotData[i,3]/PlotData[i,4]
print 'Standard Deviation kappa', np.std(S[:,0])

#Graph settings
xlabel('Computed value wind set-up without kappa')
ylabel('Measured value wind set-up [m]')
title('Scatterplot wind speed versus wind set-up')
legend(loc=2)
show()